import unittest
import kalkulacka

class MyTestCase(unittest.TestCase):

    # Testy pro sčítání
    def test_basicAdd1(self):
        x1, x2, result, choice = 3, 4, 7, 1
        operation = "sčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_basicAdd2(self):
        x1, x2, result, choice = 75, 48, 123, 1
        operation = "sčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatAdd1(self):
        x1, x2, result, choice = 7.5, 4.8, 12.3, 1
        operation = "sčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatAdd2(self):
        x1, x2, result, choice = 159.00515752245, 798.485128465112, 957.490285987562, 1
        operation = "sčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))

    # Testy pro odčítání
    def test_basicDifference1(self):
        x1, x2, result, choice = 3, 4, -1, 2
        operation = "odčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_basicDifference2(self):
        x1, x2, result, choice = 75, 48, 27, 2
        operation = "odčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatDiffence1(self):
        x1, x2, result, choice = 7.5, 4.8, 2.7, 2
        operation = "odčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatDifference2(self):
        x1, x2, result, choice = 159.00515752245, 798.485128465112, -639.479970942662, 2
        operation = "odčítání"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))

    # Testy pro násobení
    def test_basicMultiplication1(self):
        x1, x2, result, choice = 3, 4, 12, 3
        operation = "násobení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_basicMultiplication2(self):
        x1, x2, result, choice = 75, 48, 3600, 3
        operation = "násobení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatMultiplication1(self):
        x1, x2, result, choice = 7.5, 4.8, 36, 3
        operation = "násobení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatMultiplication2(self):
        x1, x2, result, choice = 159.00515752245, 798.485128465112, 126963.2536309288579491817644, 3
        operation = "násobení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))

   # Testy pro dělení
    def test_basicDivision1(self):
        x1, x2, result, choice = 8, 4, 2, 4
        operation = "dělení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_basicDivision2(self):
        x1, x2, result, choice = 75, 48, 1.5625, 4
        operation = "dělení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatDivision1(self):
        x1, x2, result, choice = 7.5, 4.8, 1.5625, 4
        operation = "dělení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))
    def test_floatDivision2(self):
        x1, x2, result, choice = 26505, 95, 279, 4
        operation = "dělení"

        self.assertEqual(kalkulacka.jednoduchyKalkulator(x1,x2,choice), result, "\nOperace " + operation + " nefunguje - vstup: x1 = " + str(x1) + ", x2 = " + str(x2) + "\nPožadovaný výsledek: " + str(result) + "\nVáš výsledek: " + str(kalkulacka.jednoduchyKalkulator(x1,x2,choice)))

    def test_zeroDivision1(self):
        x1, x2, result, choice = 15, 0, None, 4
        print("Pokud vám neprošel 'test_basicPower00', nebyla při 'x1 = 15', 'x2 = 0' a 'choice = True' vyvolána výjimka ValueError pro neurčitý výraz!")
        self.assertRaises(ValueError,lambda: kalkulacka.jednoduchyKalkulator(x1,x2, choice))

if __name__ == '__main__':
    unittest.main()